#EXMAPLE FOR DOWNLOADING TWEETS###############################################################################
## load all the necessary packages 
package = c("twitterR", "RCurl")
lapply(x, require, character.only = TRUE)

## load all the necessary libraries
library(twitteR)            #R Based Twitter Client
library(RCurl)              #General Network (HTTP/FTP/...) Client Interface for R

# use the authorisation to mine twitter tweets
api_key = "yYNXgy633ezlPaEksh23oW0Sk"
api_secret = "CTy0BIz9UXV8waFKFSulmkPOJJF5addAIIMmlrbEa73SQKPW5j"
access_token = "1004023280473427968-9DThXagPmG0UDspr48wN0nhMexH6Oq" 
access_token_secret ="KuPEqkV1woZINUECk9uQWU7tfuf1QpEAr4BbVgRfFAcxx"
setup_twitter_oauth(api_key, api_secret, access_token, access_token_secret)
1 #means yes, I want to use it

# search for specific tweets lang=en means language is inglish, n are the documents so Tweets in out case
dollar_ftse_tweets_new = searchTwitter("$FTSE", n=10000, lang ="en")
head(dollar_ftse_tweets_new, n=2)

# save the tweets 
dollar_ftse_tweets_new.df = twListToDF(dollar_ftse_tweets_new)
write.csv(dollar_ftse_tweets.df,"dollar_ftse_tweets2.df.cvs")

#DICTIONARY APPROACH#########################################################################################

## load all the necessary packages 
package = c("plyr", "dplyr", "tidyverse", "tidytext", "lubridate", "ggplot2", "stringr", "magrttr", 
            "tidyr", "broom", "widyr", "tm", "gridExtra", "lattice", "textstem", "ggstance", "scales", "readxl")
lapply(x, require, character.only = TRUE)

## load all the necessary libraries
library(plyr)               #Tools for Splitting, Applying and Combining Data
library(dplyr)              #A fast, consistent tool for working with data frame
library(tidyverse)          #Download multiple packages at once
library(tm)                 #Text Mining Package
library(tidytext)           #Text mining for word processing
library(tidyr)              #Easily Tidy Data
library(widyr)              #Widen, Process, then Re-Tidy Data
library(textstem)           #Tools for Stemming and Lemmatizing Text
library(stringr)            #Simple, Consistent Wrappers for Common String Operations
library(broom)              #Convert Statistical Analysis Objects into Tidy Tibbles
library(magrittr)           #Provides a mechanism for chaining commands with a new forward-pipe operator, %>%
library(lubridate)          #Functions to work with date-times and time-spans
library(ggplot2)            #Create Elegant Data Visualisations Using the Grammar of Graphics
library(ggstance)           #Horizontal 'ggplot2' Components
library(lattice)            #A powerful and elegant high-level data visualization system
library(gridExtra)          #Miscellaneous Functions for "Grid" Graphics
library(scales)             #Scale Functions for Visualization
library(readxl)             #Read Excel Files

## remove everything in the global environment and all the plots
rm (list = ls(all=TRUE))
graphics.off()

## set working directory
setwd("")
setwd("~/Tanja/Master Studium/Semester 4/Master thesis/Analyse/Data/Final_code")

## load the tweets data 
# select only text and time and add a column to count all the documents (tweets)
tweets = read.csv("~/tw.df.cvs")
tweets$doc = seq.int(nrow(tweets))
tweets = tweets %>%
  dplyr::select(doc, text, created)

## start cleaning text  
# define how to remove:
# https pattern 
# patterns like <f0><U+009F><U+0098><U+00AD>
# load stop words
replace_reg = "https://t.co/[a-zA-Z0-9]+|http://[a-zA-Z0-9]+|&amp;|&lt;|&gt;|RT|https"
unnest_reg = "([^A-Za-z_\\@]|(?![A-Za-z_\\@]))"
stopwor = read_delim("~/stopwor.txt", 
                     "\t", escape_double = FALSE, trim_ws = TRUE)


# remove the unnecessary text elements:
# htts
# words that start with @ 
# the pattern
# digits
# punctionation
# apostrophe
# terms that are one or two letters long
tidy_tweets = tweets %>% 
  mutate(text = str_replace_all(text, replace_reg, "")) %>%
  mutate(text = gsub("@\\w+", "",text)) %>%
  mutate(text = gsub("(<[^>]{0,}>|\\r|\\n)", "", text)) %>%
  mutate(text = gsub("[[:digit:]]", "", text)) %>%
  mutate(text = gsub("(['])|[[:punct:]]", " ", text)) %>%
  mutate(text = gsub("\\b\\w{1,2}\\s", " ", text)) 

# represent the tidy tweets in a bigram
# split the bigram into a column of the first and second word
# filter stopwords in the first and second word
tweets_bigrams = tidy_tweets %>%
  unnest_tokens(bigram, text, token = "ngrams", n = 2)
bigrams_separated = tweets_bigrams %>%
  separate(bigram, c("word1", "word2"), sep = " ")
bigrams_filtered = bigrams_separated %>%
  filter(!word1 %in% stopwor$word) %>%
  filter(!word2 %in% stopwor$word) 

# lemmatize words 
# create a dictionary of lemmatized words
# apply it to the dictionary to the bigram words
lemma = make_lemma_dictionary(bigrams_filtered$word2)
bigrams_filtered$wordlemma = lemma$lemma[match(bigrams_filtered$word2, lemma$token)]
bigrams_filtered$wordlemma = ifelse(!is.na(bigrams_filtered$wordlemma), 
                                    bigrams_filtered$wordlemma, 
                                    bigrams_filtered$word2)
bigrams_filtered$word = bigrams_filtered$wordlemma
bigrams_filtered$wordlemma = NULL

## match time: 
# match trading hours
bigrams_filtered$timestamp = ymd_hms(bigrams_filtered$created)
bigrams_filtered$hours = as.numeric(format(bigrams_filtered$timestamp, "%H")) +
  as.numeric(format(bigrams_filtered$timestamp, "%M"))/60

bigrams_filtered$timestamp = ifelse(bigrams_filtered$hours >= 0 & bigrams_filtered$hours <= 16.5, 
                                    as.Date(bigrams_filtered$created), as.Date(bigrams_filtered$created) + 1)
bigrams_filtered$timestamp = as.Date(bigrams_filtered$timestamp, origin = "1970-01-01")
bigrams_filtered$hours = NULL

# match weekend = monday
bigrams_filtered$weekday = weekdays(bigrams_filtered$timestamp)
bigrams_filtered$timestamp2 = ifelse(bigrams_filtered$weekday == "Samstag",
                                     as.Date(bigrams_filtered$timestamp) + 1, 
                                     bigrams_filtered$timestamp)
bigrams_filtered$timestamp2 = as.Date(bigrams_filtered$timestamp2, origin = "1970-01-01")
bigrams_filtered$weekday2 = weekdays(bigrams_filtered$timestamp2)
bigrams_filtered$timestamp3 = ifelse(bigrams_filtered$weekday2 == "Sonntag",
                                     as.Date(bigrams_filtered$timestamp2) + 1,
                                     bigrams_filtered$timestamp)
bigrams_filtered$timestamp3 = as.Date(bigrams_filtered$timestamp3, origin = "1970-01-01")
bigrams_filtered = bigrams_filtered %>%
  dplyr::select(doc, word1, word, timestamp3)
colnames(bigrams_filtered) =c("doc", "word1","word", "timestamp")

## develop the sentiment dictionary 
# apply tf-idf and identify the most important words
clean_tweets = bigrams_filtered %>%
  group_by(word) %>%
  mutate(n = n()) %>%
  ungroup() %>%
  group_by(doc) %>%
  mutate(total = sum(n)) %>%
  ungroup() %>%
  bind_tf_idf(word, doc, n) %>%
  arrange(desc(tf_idf)) %>%
  filter(!near(tf, 1))

# load the sentiment dictionary of Loughran 
# augment the sentiment dictionary with words from tf-idf
sent_dict = get_sentiments("loughran") 
sent_dict = bind_rows(sent_dict, 
                      data_frame(word = c("oof","migration", "lagging", "roar","quiet", 
                                          "joke", "avoid", "shit","scalpin","confidence",
                                          "attempt","smartest","pure", "valued", "prophecy"), 
                                 sentiment = c("negative", "positive", "negative", "positive", "negative", 
                                               "negative", "negative", "negative", "positive", "positive",
                                               "positive", "positive", "positive", "positive", "positive")))

## match the dictionary with the bigrams and pay attention to negation words
# match the dictionary
target = c("positive", "negative")
sentiment = bigrams_filtered %>%
  inner_join(sent_dict) %>%
  filter(sentiment %in% target)

# define negation words 
# if a negation word is in the first column than change the category to the opposite
negation = c("arent", "isnt", "dont", "wont", "no", "none", "hasnt", "aint", "didnt", "havent", 
             "shouldnt", "couldnt", "wouldnt", "cannot", "werent", "wasnt",
             "aren", "isn",  "don", "won", "hasn", "ain", "didn", "haven",
             "shouldn", "couldn", "wouldn", "canno", "weren", "wasn")
sentiment$match = sentiment$word1 %in% negation
sentiment$pol = ifelse(sentiment$match == "TRUE" & sentiment$sentiment == "positive", 
                       "negative", sentiment$sentiment)
sentiment$pol2 = ifelse(sentiment$match == "TRUE" & sentiment$sentiment == "negative",
                        "positive", sentiment$pol)
sentiment = sentiment %>%
  dplyr::select(doc, timestamp, word1, word, pol2)
colnames(sentiment)[colnames(sentiment)=="pol2"] = "sentiment"

## show the most important sentiment words
sentiment %>%
  count(word) %>%
  inner_join(get_sentiments("loughran"), by = "word") %>%
  group_by(sentiment) %>%
  top_n(10, n) %>%
  ungroup() %>%
  filter(sentiment %in% target) %>%
  mutate(word = reorder(word, n)) %>%
  ggplot(aes(word, n)) +
  geom_col() +
  coord_flip() +
  facet_wrap(~ sentiment, scales = "free") #+
#ylab("The most frequent words")

## develop the sentiment time series
# how often is a sentiment word mentioned during the day 
# total word number during a day
# total words in the whole period
sentiment_by_time = sentiment %>%
  count(timestamp, sentiment) %>%         
  ungroup() %>%
  group_by(timestamp) %>%            
  mutate(time_total = sum(n)) %>%    
  group_by(sentiment) %>%
  mutate(sentiment_total = sum(n)) %>%    
  ungroup() 

# splitt the data into a negative and
# positive dataframe 
# merge into a dataframe
negative = sentiment_by_time[ which(sentiment_by_time$sentiment == "negative"), ] %>%
  dplyr::select(timestamp, sentiment, n, time_total)
colnames(negative) = c("timestamp", "sentimen_neg", "n_neg", "time_total_neg")

positive = sentiment_by_time[ which(sentiment_by_time$sentiment == "positive"), ] %>%
  dplyr::select(timestamp, sentiment, n, time_total)
colnames(positive) = c("timestamp", "sentimen_pos", "n_pos", "time_total_pos")
bind = merge(positive, negative, all = TRUE)
bind[is.na(bind)] = 0

# calculate the series as defined in 16-18
bind = bind %>%
  mutate(bind = log((1+n_pos)/(1+n_neg))) %>%
  mutate(TIS = (n_pos+1)/(n_pos + n_neg +1)) %>%
  mutate(lagTIS = lag(TIS)) %>%
  mutate(RTIS = TIS/lagTIS)
bind = bind[-1,]

## plot the final time series
# define bind
# define TIS
# define RTIS
# combine into one picture
bind.pl = ggplot(data = bind, aes(x = as.Date(timestamp), y = bind))+
  geom_line(color = "gray22", size = 1.5 ) +
  expand_limits(y = c(-2, 1)) + 
  theme(legend.title = element_blank(), axis.title.x = element_blank()) +
  scale_x_date(breaks = date_breaks("1 week"),
               labels = date_format("%D")) +
  ylab("BIND") +
  geom_hline(yintercept=0,  linetype="dashed", color="gray42") #+
#ggtitle("Sentiment Over Time")

TIS.pl = ggplot(data = bind, aes(x = as.Date(timestamp), y = TIS))+
  geom_line(color = "gray22", size = 1.5 ) +
  expand_limits(y = c(-0.1, 0.7)) + 
  geom_hline(yintercept = 0.5,  linetype = "dashed", color = "gray42") +
  theme(legend.title = element_blank(), axis.title.x = element_blank()) +
  scale_x_date(breaks = date_breaks("1 week"),
               labels = date_format("%D")) +
  ylab("TIS") #+ 
#ggtitle("Sentiment Over Time")

RTIS.pl = ggplot(data = bind, aes(x = as.Date(timestamp), y = RTIS))+
  geom_line(color = "gray22", size = 1.5 ) +
  expand_limits(y = c(-0.01, 2)) +
  geom_hline(yintercept = 1,  linetype = "dashed", color = "gray42") +
  theme(legend.title = element_blank(), axis.title.x = element_blank()) +
  scale_x_date(breaks = date_breaks("1 week"),
               labels = date_format("%D")) +
  ylab("RTIS") #+ 
#ggtitle("Sentiment Over Time")

grid.arrange(bind.pl, TIS.pl, RTIS.pl,  nrow = 3)

#NAIVE BAYES#################################################################################################    

## load all the necessary packages 
package = c("caret", "e1071", "mixedsde", "RTextTools", "glmnet", "reshape")
lapply(x, require, character.only = TRUE)

## load all the necessary libraries
library(caret)                #Classification and Regression Training
library(e1071)                #Misc Functions of the Department of Statistics, Probability Theory Group
library(mixedsde)             #Estimation Methods for Stochastic Differential Mixed Effects Models
library(RTextTools)           #Automatic Text Classification via Supervised Learning
library(glmnet)               #Lasso and Elastic-Net Regularized Generalized Linear Models
library(reshape)              #Flexibly Reshape Data

## remove everything in the global environment and all the plots    
rm (list = ls(all=TRUE))
graphics.off()

## load the manually labelled data
# set the class, so the category as a factor otherwise the algorithm will not work
tweets = read_excel("tweets.xlsx")
tweets = read_excel("bearbull.xlsx")
tweets$class = as.factor(tweets$class)
tweets$id = seq.int(nrow(tweets))
tweets$X1 = NULL

## represent the data as a text corpus 
# take a lot at it
corpus = Corpus(VectorSource(tweets$text))
inspect(corpus[1:100])

## start cleaning the data
# define:
# https pattern
# patterns like <f0><U+009F><U+0098><U+00AD>
# words that start with @
# words that start with $
# words that start with #
# words that are only one or two letters long
# apply gsub function also to tm_map
replace_reg = "https://t.co/[a-zA-Z0-9]+|http://[a-zA-Z0-9]+|&amp;|&lt;|&gt;|RT|https"
replace_brakets = "(<[^>]{0,}>|\\r|\\n)"
replace_at = "@\\w+"
replace_dol = "\\$\\w+"
replace_has = "\\#\\w+"
replace_let = "\\b\\w{1,2}\\s"
toSpace = content_transformer(function(x, pattern) {return (gsub(pattern," ", x))})

# remove:
# words that start with $
# remain alphabetic characters and punctuation
# https
# words that start with @
# words that start with #
# lowercase all the words
# punctuation
# numbers
# remove too big space to normal space
# stem words
corpus.clean = corpus %>%
  tm_map(toSpace, replace_dol) %>%
  tm_map(toSpace,"[^[:graph:]]") %>%
  tm_map(toSpace, replace_reg) %>%
  tm_map(toSpace, replace_brakets) %>%
  tm_map(toSpace, replace_at) %>%
  tm_map(toSpace, replace_has) %>%
  tm_map(content_transformer(tolower)) %>% 
  tm_map(removePunctuation) %>%
  tm_map(removeNumbers) %>%
  tm_map(removeWords, stopwords(kind="en")) %>%
  tm_map(toSpace, replace_let) %>%
  tm_map(stripWhitespace) %>%
  tm_map(stemDocument)
inspect(corpus.clean[1:160])

## represent the cleaned data in a matrix representation: bag of words
# take a look at it
# what is the size
dtm = DocumentTermMatrix(corpus.clean)
inspect(dtm)
dim(dtm)

# after cleaning some rows are completly empty, so remove these rows
# remove the same rows also from the data frame and corpus to have a sample with the same length in the end
# also remove rows where only two words exist 
rowTotals = apply(dtm , 1, sum)
empty.rows = dtm[rowTotals <= 2, ]$dimnames[1][[1]]
corpus = corpus[-as.numeric(empty.rows)]
corpus.clean = corpus.clean[-as.numeric(empty.rows)]
tweets = tweets[!(tweets$id %in% empty.rows),]
dtm = DocumentTermMatrix(corpus.clean)
dim(dtm)
corpus.clean.df = as.matrix(dtm)

# the data represented in a matrix is very sparce to reduce its size tfidf is used
dtm = DocumentTermMatrix(corpus.clean, control = list(weighting = weightTfIdf))
dtm = removeSparseTerms(dtm, 0.99)

## define the training and testing data set of: 70% & 30% 
# to the data frame
# document term index 
# corpus 
# it is necessary that the size is the same for all of them 
# df_trainIndex identifies when the 70% is reached and n in tweets identifies the end of the sample size
# Attention: it needs to changed for the NAIVE BAYES with downloaded tweets to [1:11703,] for train
# & [11704:16718,] for test
n = nrow(tweets)
df_trainIndex = sample(1:n, size = round(0.7*n), replace=FALSE)
df.train = tweets[1:672,]
df.test = tweets[673:960,]

dtm.train = dtm[1:672,]
dtm.test = dtm[673:960,]

corpus.clean.train = corpus.clean[1:672]
corpus.clean.test = corpus.clean[673:960]
inspect(corpus.clean.test)

# size check
dim(dtm.train)

## ignore words that are less than in 5 tweets
# remove them from training as well as for the testing dtm
freq = findFreqTerms(dtm.train, 5)
length((freq))

dtm.train.nb = DocumentTermMatrix(corpus.clean.train, control=list(dictionary = freq))
inspect(dtm.train.nb)
dim(dtm.train.nb)

dtm.test.nb = DocumentTermMatrix(corpus.clean.test, control=list(dictionary = freq))
inspect(dtm.test.nb)
dim(dtm.test.nb)

## Train the Naive Bayes algorithm
# term occurence is more important than term frequencies, so replace frequency in dtm above 1 to 1 
convert_count = function(x) {
  y = ifelse(x > 0, 1,0)
  y = factor(y, levels=c(0,1))
  y
}

# apply the function above to the train and test data
# which is the final training and testing dtms
trainNB = apply(dtm.train.nb, 2, convert_count)
testNB = apply(dtm.test.nb, 2, convert_count)

# train the classier with the training data and use laplace smoother
classifier = naiveBayes(trainNB, df.train$class, laplace = 1)

# predict the testing set from the classifier
pred = predict(classifier, newdata = testNB) 
pred

# create a truth table by tabulating the predicted class labels with the actual class labels 
table("Predictions"= pred,  "Actual" = df.test$class )

# show the confusion matrix
conf.mat = confusionMatrix(pred, df.test$class)
conf.mat
conf.mat$byClass
conf.mat$overall
conf.mat$overall['Accuracy']

## k-fold cross validation 
# set up 10-fold cross validation procedure
train_control = trainControl(method = "cv", number = 10)

# train model in the training set with 10 partioned sample sets
nb.kfold = train(x = trainNB, y = df.train$class, method = "nb", trControl = train_control)

# show the results from the training
confusionMatrix(nb.kfold)

# apply the training set to the testing data
prednb.kfold = predict(nb.kfold, newdata = testNB)

# show the confusion matrix
confusionMatrix(prednb.kfold, df.test$class)

#GRANGER CAUSALITY###########################################################################################
## load all the necessary packages 
package = c("vars", "tidyquant", "timetk", "MLmetrics", "psych", "tseries", "Metrics")
lapply(x, require, character.only = TRUE)

## load all the necessary libraries
library(vars)                 #VAR Modelling
library(tidyquant)            #Tidy Quantitative Financial Analysis 
library(timetk)               #A Tool Kit for Working with Time Series in R
library(MLmetrics)            #Machine Learning Evaluation Metrics
library(psych)                #Procedures for Psychological, Psychometric, and Personality Research
library(tseries)              #Time Series Analysis and Computational Finance
library(Metrics)              #Evaluation Metrics for Machine Learning

## remove everything in the global environment and all the plots
rm (list = ls(all=TRUE))
graphics.off()

## load data file with all the sentiment measures
ts = read_excel("~/ts.xlsx", 
                col_types = c("date", "numeric", "numeric", "numeric", "numeric", "numeric","numeric", "numeric"))

## set the time zone to Greenwich   
Sys.setenv(TZ = "UTC")

## sentiment data description
# show mean, sd, min, max etc.
# display the pairwise Pearson correlation
describe(ts[-c(1,2)])
corr.test(ts[-c(1,2)], method = "pearson")

## observe financial time series
# plot FTSE 100 series
ggplot( data = ts, aes(x = as.Date(t, '%m/%d/%Y'), y = ftse )) + 
  geom_line(color = "gray22", size = 1.5) +
  expand_limits(y=c(7500, 7800)) +
  theme(legend.title = element_blank(), axis.title.x = element_blank()) +
  scale_x_date(breaks = date_breaks("1 week"),
               labels = date_format("%D")) +
  ylab("FTSE")

# plot PCR series
ggplot( data = ts, aes(x = as.Date(t, '%m/%d/%Y'), y = pcr )) + 
  geom_line(color = "gray22", size = 1.5) +
  expand_limits(y=c(0, 2)) +
  geom_hline(yintercept = 1,  linetype="dashed", color="gray42") +
  theme(legend.title = element_blank(), axis.title.x = element_blank()) +
  scale_x_date(breaks = date_breaks("1 week"),
               labels = date_format("%D")) +
  ylab("PCR")

# plot ARMS series
ggplot( data = ts, aes(x = as.Date(t, '%m/%d/%Y'), y = arms )) + 
  geom_line(color = "gray22", size = 1.5) +
  expand_limits(y=c(0, 4)) +
  geom_hline(yintercept=1,  linetype="dashed", color="gray42") +
  theme(legend.title = element_blank(), axis.title.x = element_blank()) +
  scale_x_date(breaks = date_breaks("1 week"),
               labels = date_format("%D")) +
  ylab("FTSE")

# plot VFTSE series
ggplot( data = ts, aes(x = as.Date(t, '%m/%d/%Y'), y = vftse )) + 
  geom_line(color = "gray22", size = 1.5) +
  expand_limits(y=c(8, 16)) +
  theme(legend.title = element_blank(), axis.title.x = element_blank()) +
  scale_x_date(breaks = date_breaks("1 week"),
               labels = date_format("%D")) +
  ylab("VFTSE")

## to handle the VAR and other time series calculation convert data frame into a xts
ts.xts = ts %>%
  tk_xts(silent = TRUE)

# plot the data from xts
plot(ts.xts$ftse)
plot(ts.xts$pcr)
plot(ts.xts$arms)
plot(ts.xts$vftse)

# calculate returns
# apply log to calculate returns
# transform the returns from xts into data frame
# plot 
ts.xts$lftse = log(ts.xts$ftse)
ts.xts$lret = (diff(ts.xts$lftse))*100
ts = ts.xts %>%
  tk_tbl(timekit_idx = TRUE)
ts = ts[-1,]
plot(ts.xts$lret)  

# standardise returns for better comporability between the results
lret = ts$lret
ts.xts = ts.xts[-1,]
ts.xts$std.lret = (lret - mean(lret))/ sd(lret)
ts$std.lret = ts.xts$std.lret 

# Augmented Dickey Fuller Test
ur_ftse = ur.df(ts$ftse, type = "trend", lags = 8, selectlags = "BIC") 
summary(ur_ftse)
#result: unit root, with trend and drift
ur_ret = ur.df(ts$lret, type = "trend", lags = 8, selectlags = "BIC") 
summary(ur_ret)
#result: no unit root, with trend and drift


## Granger Causality for the first specification: RETURNS  
# Estimate the VAR(p)
# estimate VAR returns on its self + put call ratio
# prepare 
var_pcr = ts %>%
  dplyr::select(index, std.lret, pcr) %>%
  tk_xts(silent = TRUE)

# run VAR selection model
VARselect(var_pcr, lag.max = 10)
est_pcr = VAR(var_pcr, type = "const", lag.max = 10, ic = "HQ")
est_pcr
summary(est_pcr)
#-> VAR(1)

# check residuals
# plot
res_pcr = residuals(est_pcr)
plot(res_pcr)

# serial correlation in residuals
# Ho: no autocorrelation
serial.test(est_pcr, lags.pt = 10, type = "PT.asymptotic")
# Ho: no autocorrelation
serial.test(est_pcr, lags.bg = 10, type = "BG")
# -> no auto correlation

# estimate VAR returns on its self + ARMS
# prepare 
var_arms = ts %>%
  dplyr::select(index, std.lret, arms) %>%
  tk_xts(silent = TRUE)

# VAR selection model
VARselect(var_arms, lag.max = 10)
est_arms = VAR(var_arms, type = "const", lag.max = 10, ic = "HQ")
summary(est_arms)
# ->: VAR(1)

# check residuals
# plot
res_arms = residuals(est_arms)
plot(res_arms)
# serial correlation in residuals
serial.test(est_arms, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_arms, lags.bg = 10, type = "BG")
# -> no serial correlation

# estimate VAR returns on its self + VFTSE
# prepare 
var_vftse = ts %>%
  dplyr::select(index, std.lret, vftse) %>%
  tk_xts(silent = TRUE)

# VAR selection model 
VARselect(var_vftse, lag.max = 10)
est_vftse = VAR(var_vftse, type = "const", lag.max = 10, ic = "HQ")
summary(est_vftse)

est_vftse1 = VAR(var_vftse, type = "const", lag.max = 1)
est_vftse1

# check residuals 
# serial correlation in residuals
res_vftse = residuals(est_vftse)
serial.test(est_vftse, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_vftse, lags.bg = 10, type = "BG")
#-> no serial correlation

res_vftse1 = residuals(est_vftse1)
serial.test(est_vftse1, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_vftse1, lags.bg = 10, type = "BG")
#-> no serial correlation also for one lag

# estimate VAR returns on its self + BIND
# prepare 
var_bind = ts %>%
  dplyr::select(index, std.lret, bind) %>%
  tk_xts(silent = TRUE)

# VAR selection model
VARselect(var_bind, lag.max = 10)
est_bind = VAR(var_bind, type = "const", lag.max = 10, ic = "HQ")
summary(est_bind)

# serial correlation in residuals
res_sentiment = residuals(est_bind)
serial.test(est_bind, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_bind, lags.bg = 10, type = "BG")
#-> no serial correlation

# estimate VAR returns on its self + TIS
# prepare 
var_tis = ts %>%
  dplyr::select(index, std.lret, tis) %>%
  tk_xts(silent = TRUE)

# VAR selection
VARselect(var_tis, lag.max = 10)
est_tis = VAR(var_tis, type = "const", lag.max = 10, ic = "HQ")
summary(est_tis)

# serial correlation
res_sentiment = residuals(est_tis)
serial.test(est_tis, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_tis, lags.bg = 10, type = "BG")
#-> no serial correlation

# estimate VAR returns on its self + RTIS
# prepare 
var_rtis = ts %>%
  dplyr::select(index, std.lret, rtis) %>%
  tk_xts(silent = TRUE)

# VAR selection
VARselect(var_rtis, lag.max = 10)
est_rtis = VAR(var_rtis, type = "const", lag.max = 10, ic = "HQ")
summary(est_rtis)

# serial correlation
res_sentiment = residuals(est_rtis)
serial.test(est_rtis, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_rtis, lags.bg = 10, type = "BG")
#-> no serial correlation

# Granger causality for the RETURNS
# Ho: "..." does not cause the other 
causality(est_pcr, cause = "std.lret")
causality(est_pcr, cause = "pcr")
causality(est_arms, cause = "std.lret")
causality(est_arms, cause = "arms")
causality(est_vftse1, cause = "std.lret")
causality(est_vftse1, cause = "vftse")
causality(est_bind, cause = "std.lret")
causality(est_bind, cause = "bind")
causality(est_tis, cause = "std.lret")
causality(est_tis, cause = "tis")
causality(est_rtis, cause = "std.lret")
causality(est_rtis, cause = "rtis")
#-> only rtis at 10% level otherwise no granger causality

## Granger Causality for the first specification: REALIZED VOLATILITY       
# develop realized volatility       
# load the data for five minutes ftse 100
ftse.five = read_excel("~/ftse.five.min.xlsx", 
                       col_types = c("date", "numeric"))

# convert ftse to xts 
ftse.five.xts = ftse.five %>%
  tk_xts(silent = TRUE)

# calculate returns
ftse.five.xts$lftse = log(ftse.five$ftse.five)
ftse.five.xts$lret = (diff(ftse.five.xts$lftse))*100

# ass. mean = 0, count returns^2
ftse.five.xts$lret2 = ftse.five.xts$lret**2

# rename NA to 0 in xts and table
ftse.five = ftse.five.xts %>%
  tk_tbl(timekit_idx = TRUE)
ftse.five[is.na(ftse.five)] = 0
ftse.five.xts[is.na(ftse.five.xts)] = 0

# represent the returns in a matrix where row is the date and columns the intraday returns
# remove the first column because retun is calculated with the previous day
intra.returns = ftse.five.xts$lret2
intra.returns = matrix(intra.returns, ncol = 103, byrow = TRUE)
intra.returns = intra.returns[,-1]

# sum the rows and take the square root
real.va = rowSums(intra.returns)
real.vol = sqrt(real.va)
real.vol = real.vol[-1]

# represent finally in a table with ts 
ts_real.vol = read_excel("~/ts.xlsx", 
                         col_types = c("date", "numeric", "numeric", "numeric", "numeric", "numeric","numeric", "numeric"))
ts_real.vol = cbind(ts_real.vol, real.vol)
real.vol.xts = ts_real.vol %>%
  tk_xts(silent = TRUE)

# plot it 
plot(real.vol.xts$real.vol)

# Estimate the VAR(p)
# estimate VAR realized vol on its self + put call ratio
# prepare 
var_real.vol_pcr = ts_real.vol %>%
  dplyr::select(t, real.vol, pcr) %>%
  tk_xts(silent = TRUE)

# run VAR selection model
VARselect(var_real.vol_pcr, lag.max = 10)
est_real.vol_pcr = VAR(var_real.vol_pcr, type = "const", lag.max = 10, ic = "HQ")
summary(est_real.vol_pcr)
#-> VAR(1)

# check residuals
# plot
res_pcr = residuals(est_real.vol_pcr)
plot(res_pcr)

# serial correlation in residuals
# Ho: no autocorrelation
serial.test(est_real.vol_pcr, lags.pt = 10, type = "PT.asymptotic")
# Ho: no autocorrelation
serial.test(est_real.vol_pcr, lags.bg = 10, type = "BG")
# -> no auto correlation

# estimate VAR realized volatility on its self + ARMS
# prepare 
var_real.vol_arms = ts_real.vol %>%
  dplyr::select(t, real.vol, arms) %>%
  tk_xts(silent = TRUE)

# VAR selection model
VARselect(var_real.vol_arms, lag.max = 10)
est_real.vol_arms = VAR(var_real.vol_arms, type = "const", lag.max = 10, ic = "HQ")
est_real.vol_arms
# ->: VAR(1)

# check residuals
# plot
res_arms = residuals(est_real.vol_arms)
plot(res_arms)
# serial correlation in residuals
serial.test(est_real.vol_arms, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_real.vol_arms, lags.bg = 10, type = "BG")
# -> no serial correlation

# estimate VAR realized volatility on its self + VFTSE
# prepare 
var_real.vol_vftse = ts_real.vol %>%
  dplyr::select(t, real.vol, vftse) %>%
  tk_xts(silent = TRUE)

# VAR selection model 
VARselect(var_real.vol_vftse, lag.max = 10)
est_real.vol_vftse = VAR(var_real.vol_vftse, type = "const", lag.max = 10, ic = "HQ")
est_real.vol_vftse

# check residuals 
# serial correlation in residuals
res_vftse = residuals(est_real.vol_vftse)
serial.test(est_real.vol_vftse, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_real.vol_vftse, lags.bg = 10, type = "BG")
#-> no serial correlation

# estimate VAR realized volatility on its self + BIND
# prepare 
var_real.vol_bind = ts_real.vol %>%
  dplyr::select(t, real.vol, bind) %>%
  tk_xts(silent = TRUE)

# VAR selection model
VARselect(var_real.vol_bind, lag.max = 10)
est_real.vol_bind = VAR(var_real.vol_bind, type = "const", lag.max = 10, ic = "HQ")
est_real.vol_bind

# serial correlation in residuals
res_sentiment = residuals(est_real.vol_bind)
serial.test(est_real.vol_bind, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_real.vol_bind, lags.bg = 10, type = "BG")
#-> no serial correlation

# estimate VAR realized volatility on its self + TIS
# prepare 
var_real.vol_tis = ts_real.vol %>%
  dplyr::select(t, real.vol, tis) %>%
  tk_xts(silent = TRUE)

# VAR selection
VARselect(var_real.vol_tis, lag.max = 10)
est_real.vol_tis = VAR(var_real.vol_tis, type = "const", lag.max = 10, ic = "HQ")
est_real.vol_tis

# serial correlation
res_sentiment = residuals(est_real.vol_tis)
serial.test(est_real.vol_tis, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_real.vol_tis, lags.bg = 10, type = "BG")
#-> no serial correlation

# estimate VAR realized volatility on its self + RTIS
# prepare 
var_real.vol_rtis = ts_real.vol %>%
  dplyr::select(t, real.vol, rtis) %>%
  tk_xts(silent = TRUE)

# VAR selection
VARselect(var_real.vol_rtis, lag.max = 10)
est_real.vol_rtis = VAR(var_real.vol_rtis, type = "const", lag.max = 10, ic = "HQ")
est_real.vol_rtis

# serial correlation
res_sentiment = residuals(est_real.vol_rtis)
serial.test(est_real.vol_rtis, lags.pt = 10, type = "PT.asymptotic")
serial.test(est_real.vol_rtis, lags.bg = 10, type = "BG")
#-> no serial correlation

# Granger causality for the realized volatility
# Ho: "..." does not cause the other 
causality(est_real.vol_pcr, cause = "real.vol")
causality(est_real.vol_pcr, cause = "pcr")
causality(est_real.vol_arms, cause = "real.vol")
causality(est_real.vol_arms, cause = "arms")
causality(est_real.vol_vftse, cause = "real.vol")
causality(est_real.vol_vftse, cause = "vftse")
causality(est_real.vol_bind, cause = "real.vol")
causality(est_real.vol_bind, cause = "bind")
causality(est_real.vol_tis, cause = "real.vol")
causality(est_real.vol_tis, cause = "tis")
causality(est_real.vol_rtis, cause = "real.vol")
causality(est_real.vol_rtis, cause = "rtis")
#-> only vftse and realised vol. at 5% level otherwise no granger causality

#MAPE & RMSE#################################################################################################
## Accuracy measurement MAPE & RMSE for returns 
# Baseline
# select the relevant variables
# show lags
var_lret = ts %>%
  dplyr::select(index, lret) %>%
  tk_xts(silent = TRUE)

var_lret = var_lret %>%
  lag.xts(k = 0:1)
var_lret = na.omit(var_lret)

# define the training and the testing set
# run the linear regression in the training set
n = dim(var_lret)[1]
training_lret = var_lret[1:(n-5)]
test_lret = var_lret[(n-4):n]
lret.train = lm(lret ~ lret.1, data = training_lret)
summary(lret.train)

# predict the linear regression in the test set
test_lret$lret.test = predict(lret.train, newdata = test_lret)

# calculate the deviation
MAPE(test_lret$lret.test, test_lret$lret)
rmse(test_lret$lret, test_lret$lret.test)

# returns + PCR
# select the relevant variables
# show lags
var_pcr = ts %>%
  dplyr::select(index, lret, pcr) %>%
  tk_xts(silent = TRUE)

var_pcr = var_pcr %>%
  lag.xts(k = 0:1)
var_pcr = na.omit(var_pcr)

# define the training and the testing set
# run the linear regression in the training set
n = dim(var_pcr)[1]
training_pcr = var_pcr[1:(n-5)]
test_pcr = var_pcr[(n-4):n]
pcr.train = lm(lret ~ lret.1 + pcr.1, data = training_pcr)
summary(pcr.train)

# predict the linear regression in the test set
test_pcr$pcr.test = predict(pcr.train, newdata = test_pcr)

# calculate the deviation
MAPE(test_pcr$pcr.test, test_pcr$lret)
rmse(test_pcr$lret, test_pcr$pcr.test)

# returns + ARMS
# select the relevant variables
# show lags
var_arms = ts %>%
  dplyr::select(index, lret, arms) %>%
  tk_xts(silent = TRUE)

var_arms = var_arms %>%
  lag.xts(k = 0:1)
var_arms = na.omit(var_arms)

# define the training and the testing set
# run the linear regression in the training set
n = dim(var_arms)[1]
training_arms = var_arms[1:(n-5)]
test_arms = var_arms[(n-4):n]
arms.train = lm(lret ~ lret.1 + arms.1, data = training_arms)
summary(arms.train)

# predict the linear regression in the test set   
test_arms$arms.test = predict(arms.train, newdata = test_arms)

# calculate the deviation
MAPE(test_arms$arms.test, test_arms$lret)
rmse(test_arms$lret, test_arms$arms.test)

# returns + VFTSE
# select the relevant variables
# show lags
var_vftse = ts %>%
  dplyr::select(index, lret, vftse) %>%
  tk_xts(silent = TRUE)

var_vftse = var_vftse %>%
  lag.xts(k = 0:1)
var_vftse = na.omit(var_vftse)

# define the training and the testing set
# run the linear regression in the training set  
n = dim(var_vftse)[1]
training_vftse = var_vftse[1:(n-5)]
test_vftse = var_vftse[(n-4):n]
vftse.train = lm(lret ~ lret.1 + vftse.1, data = training_vftse)
summary(vftse.train)

# predict the linear regression in the test set
test_vftse$vftse.test = predict(vftse.train, newdata = test_vftse)

MAPE(test_vftse$vftse.test, test_vftse$lret)
rmse(test_vftse$lret, test_vftse$vftse.test)

# returns + BIND
# select the relevant variables
# show lags
var_bind = ts %>%
  dplyr::select(index, lret, bind) %>%
  tk_xts(silent = TRUE)

var_bind = var_bind %>%
  lag.xts(k = 0:1)
var_bind = na.omit(var_bind)

# define the training and the testing set
# run the linear regression in the training set
n = dim(var_bind)[1]
training_bind = var_bind[1:(n-5)]
test_bind = var_bind[(n-4):n]
bind.train = lm(lret ~ lret.1 + bind.1, data = training_bind)
summary(bind.train)

# predict the linear regression in the test set
test_bind$bind.test = predict(bind.train, newdata = test_bind)

# calculate the deviation
MAPE(test_bind$bind.test, test_bind$lret)
rmse(test_bind$lret, test_bind$bind.test)

# returns + RTIS
# select the relevant variables
# show lags
var_rtis = ts %>%
  dplyr::select(index, lret, rtis) %>%
  tk_xts(silent = TRUE)

var_rtis = var_rtis %>%
  lag.xts(k = 0:1)
var_rtis = na.omit(var_rtis)

# define the training and the testing set
# run the linear regression in the training set
n = dim(var_rtis)[1]
training_rtis = var_rtis[1:(n-5)]
test_rtis = var_rtis[(n-4):n]
rtis.train = lm(lret ~ lret.1 + rtis.1, data = training_rtis)
summary(rtis.train)

# predict the linear regression in the test set
test_rtis$rtis.test = predict(rtis.train, newdata = test_rtis)

# calculate the deviation
MAPE(test_rtis$rtis.test, test_rtis$lret)
rmse(test_rtis$lret, test_rtis$rtis.test)

## Accuracy measurement MAPE & RMSE for returns
# Baseline
# select the relevant variables
# show lags
real.vol = ts_real.vol %>%
  dplyr::select(t, real.vol) %>%
  tk_xts(silent = TRUE)

real.vol = real.vol %>%
  lag.xts(k = 0:1)
real.vol = na.omit(real.vol)

# define the training and the testing set
# run the linear regression in the training set
n = dim(real.vol)[1]
training_real.vol = real.vol[1:(n-5)]
test_real.vol = real.vol[(n-4):n]
real.vol.train = lm(real.vol ~ real.vol.1, data = training_real.vol)
summary(real.vol.train)

# predict the linear regression in the test set
test_real.vol$real.vol.test = predict(real.vol.train, newdata = test_real.vol)

# calculate the deviation
MAPE(test_real.vol$real.vol.test, test_real.vol$real.vol)
rmse(test_real.vol$real.vol, test_real.vol$real.vol.test)

# realised volatility + PCR
# select the relevant variables
# show lags    
real.vol_pcr = ts_real.vol %>%
  dplyr::select(t, real.vol, pcr) %>%
  tk_xts(silent = TRUE)

real.vol_pcr = real.vol_pcr %>%
  lag.xts(k = 0:1)
real.vol_pcr = na.omit(real.vol_pcr)

# define the training and the testing set
# run the linear regression in the training set
n = dim(real.vol_pcr)[1]
training_real.vol_pcr = real.vol_pcr[1:(n-5)]
test_real.vol_pcr = real.vol_pcr[(n-4):n]
real.vol_pcr.train = lm(real.vol ~ real.vol.1 + pcr.1, data = training_real.vol_pcr)
summary(real.vol_pcr.train)

# predict the linear regression in the test set
test_real.vol_pcr$pcr.test = predict(real.vol_pcr.train, newdata = test_real.vol_pcr)

# calculate the deviation
MAPE(test_real.vol_pcr$pcr.test, test_real.vol_pcr$real.vol)
rmse(test_real.vol_pcr$real.vol, test_real.vol_pcr$pcr.test)

# realised volatility + ARMS
# select the relevant variables
# show lags
real.vol_arms = ts_real.vol %>%
  dplyr::select(t, real.vol, arms) %>%
  tk_xts(silent = TRUE)

# define the training and the testing set
# run the linear regression in the training set
real.vol_arms = real.vol_arms %>%
  lag.xts(k = 0:1)
real.vol_arms = na.omit(real.vol_arms)

# predict the linear regression in the test set
n = dim(real.vol_arms)[1]
training_real.vol_arms = real.vol_arms[1:(n-5)]
test_real.vol_arms = real.vol_arms[(n-4):n]
arms.train = lm(real.vol ~ real.vol.1 + arms.1, data = training_real.vol_arms)
summary(arms.train)

# predict the linear regression in the test set
test_real.vol_arms$arms.test = predict(arms.train, newdata = test_real.vol_arms)

# calculate the deviation
MAPE(test_real.vol_arms$arms.test, test_real.vol_arms$real.vol)
rmse(test_real.vol_arms$real.vol, test_real.vol_arms$arms.test)

# realised volatility + VFTSE
# select the relevant variables
# show lags
real.vol_vftse = ts_real.vol %>%
  dplyr::select(t, real.vol, vftse) %>%
  tk_xts(silent = TRUE)

real.vol_vftse = real.vol_vftse %>%
  lag.xts(k = 0:2)
real.vol_vftse = na.omit(real.vol_vftse)

# define the training and the testing set
# run the linear regression in the training set
n = dim(real.vol_vftse)[1]
training_real.vol_vftse = real.vol_vftse[1:(n-5)]
test_real.vol_vftse = real.vol_vftse[(n-4):n]
vftse.train = lm(real.vol ~ real.vol.1 + vftse.1, data = training_real.vol_vftse)
summary(vftse.train)

# predict the linear regression in the test set
test_real.vol_vftse$vftse.test = predict(vftse.train, newdata = test_real.vol_vftse)

# calculate the deviation
MAPE(test_real.vol_vftse$vftse.test, test_real.vol_vftse$real.vol)
rmse(test_real.vol_vftse$real.vol, test_real.vol_vftse$vftse.test)

# realised volatility + BIND
# select the relevant variables
# show lags
real.vol_bind = ts_real.vol %>%
  dplyr::select(t, real.vol, bind) %>%
  tk_xts(silent = TRUE)

real.vol_bind = real.vol_bind %>%
  lag.xts(k = 0:1)
real.vol_bind = na.omit(real.vol_bind)

# define the training and the testing set
# run the linear regression in the training set
n = dim(real.vol_bind)[1]
training_real.vol_bind = real.vol_bind[1:(n-5)]
test_real.vol_bind = real.vol_bind[(n-4):n]
bind.train = lm(real.vol ~ ., data = training_real.vol_bind)
summary(bind.train)

# predict the linear regression in the test set
test_real.vol_bind$bind.test = predict(bind.train, newdata = test_real.vol_bind)

# calculate the deviation
MAPE(test_real.vol_bind$bind.test, test_real.vol_bind$real.vol)
rmse(test_real.vol_bind$real.vol, test_real.vol_bind$bind.test)

# realised volatility + RTIS
# select the relevant variables
# show lags
real.vol_rtis = ts_real.vol %>%
  dplyr::select(t, real.vol, rtis) %>%
  tk_xts(silent = TRUE)

real.vol_rtis = real.vol_rtis %>%
  lag.xts(k = 0:1)
real.vol_rtis = na.omit(real.vol_rtis)

# define the training and the testing set
# run the linear regression in the training set
n = dim(real.vol_rtis)[1]
training_real.vol_rtis = real.vol_rtis[1:(n-5)]
test_real.vol_rtis = real.vol_rtis[(n-4):n]
rtis.train = lm(real.vol ~ real.vol.1 + rtis.1, data = training_real.vol_rtis)
summary(rtis.train)

# predict the linear regression in the test set
test_real.vol_rtis$rtis.test = predict(rtis.train, newdata = test_real.vol_rtis)

# calculate the deviation
MAPE(test_real.vol_rtis$rtis.test, test_real.vol_rtis$real.vol)
rmse(test_real.vol_rtis$real.vol, test_real.vol_rtis$rtis.test)
################################################################################################################